.include "x16.inc"
.include "x16lib.inc"

jsr Loadx16Lib      ;load x16lib in rambank 1 (see x16lib.s)
jsr TestHighram

TestHighram:
jmp TestHighram_start
    st1:    .asciiz "red"
    st2:    .asciiz "blue"
    st3:    .asciiz "green"
    st4:    .asciiz "orange"
    st5:    .res 100,$20
    
    st1Name: .asciiz "st1"
    st2Name: .asciiz "st2"
    st3Name: .asciiz "st3"
    
    
TestHighram_start:

    ;Write st1 to rambank 5
    lda #<st1
    sta r0
    lda #>st1
    sta r0+1 

    lda #<st1Name
    sta r2
    lda #>st1Name
    sta r2+1 

    ldx #5
    stx $BFFF   ;rambank
    jsr fSaveToHighmem
    
    ;Write st2 to rambank 5
    lda #<st2
    sta r0
    lda #>st2
    sta r0+1 

    lda #<st2Name
    sta r2
    lda #>st2Name
    sta r2+1 

    jsr fSaveToHighmem

    ;Write st3 to rambank 5
    lda #<st3
    sta r0
    lda #>st3
    sta r0+1 

    lda #<st3Name
    sta r2
    lda #>st3Name
    sta r2+1 

    jsr fSaveToHighmem

    ;Overwrite st2 with the value in st3 to rambank 5
    lda #<st4
    sta r0
    lda #>st4
    sta r0+1 

    lda #<st2Name
    sta r2
    lda #>st2Name
    sta r2+1 
    jsr fSaveToHighmem

    ;Read st2 from highrem and store in st5
    lda #<st5
    sta r0
    lda #>st5
    sta r0+1 

    lda #<st2Name
    sta r2
    lda #>st2Name
    sta r2+1 

    jsr fReadFromHighmem
    
    ldx #0
    :
        lda st5,X
        jsr CHROUT
        inx
        cmp #0
        bne :-
    
rts